org.apache.cassandra.db.marshal

## Class BytesType

- java.lang.Object
- - org.apache.cassandra.db.marshal.AbstractType<java.nio.ByteBuffer>
  - - org.apache.cassandra.db.marshal.BytesType

All Implemented Interfaces:
  java.util.Comparator<java.nio.ByteBuffer>

    public class BytesType
    extends AbstractType<java.nio.ByteBuffer>

### Field Summary

Fields
`static BytesType` `instance`

### Fields inherited from class org.apache.cassandra.db.marshal.AbstractType

`reverseComparator`

### Method Summary

Methods
`CQL3Type` `asCQL3Type()`
`int` `compare(java.nio.ByteBuffer o1, java.nio.ByteBuffer o2)`
`java.nio.ByteBuffer` `fromString(java.lang.String source)` get a byte representation of the given string.
`TypeSerializer<java.nio.ByteBuffer>` `getSerializer()`
`boolean` `isByteOrderComparable()`
`boolean` `isCompatibleWith(AbstractType<?> previous)` Returns true if this comparator is compatible with the provided previous comparator, that is if previous can safely be replaced by this.
`boolean` `isValueCompatibleWithInternal(AbstractType<?> otherType)` Needed to handle ReversedType in value-compatibility checks.

### Methods inherited from class org.apache.cassandra.db.marshal.AbstractType

`compareCollectionMembers, componentsCount, compose, decompose, fromStringCQL2, getComponents, getString, getString, isCollection, isCounter, isValueCompatibleWith, parseDefaultParameters, toString, validate, validateCellValue, validateCollectionMember`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Comparator

`equals`

### Field Detail

#### instance

    public static final BytesType instance

### Method Detail

#### compare

    public int compare(java.nio.ByteBuffer o1,
              java.nio.ByteBuffer o2)

#### fromString

    public java.nio.ByteBuffer fromString(java.lang.String source)

Description copied from class: `AbstractType`
get a byte representation of the given string.

Specified by:
  `fromString` in class `AbstractType<java.nio.ByteBuffer>`

#### isCompatibleWith

    public boolean isCompatibleWith(AbstractType<?> previous)

Description copied from class: `AbstractType`
Returns true if this comparator is compatible with the provided previous comparator, that is if previous can safely be replaced by this. A comparator cn should be compatible with a previous one cp if forall columns c1 and c2, if cn.validate(c1) and cn.validate(c2) and cn.compare(c1, c2) == v, then cp.validate(c1) and cp.validate(c2) and cp.compare(c1, c2) == v. Note that a type should be compatible with at least itself and when in doubt, keep the default behavior of not being compatible with any other comparator!

Overrides:
  `isCompatibleWith` in class `AbstractType<java.nio.ByteBuffer>`

#### isValueCompatibleWithInternal

    public boolean isValueCompatibleWithInternal(AbstractType<?> otherType)

Description copied from class: `AbstractType`
Needed to handle ReversedType in value-compatibility checks. Subclasses should implement this instead of isValueCompatibleWith().

Overrides:
  `isValueCompatibleWithInternal` in class `AbstractType<java.nio.ByteBuffer>`

#### isByteOrderComparable

    public boolean isByteOrderComparable()

Overrides:
  `isByteOrderComparable` in class `AbstractType<java.nio.ByteBuffer>`
Returns:
  true IFF the byte representation of this type can be compared unsigned and always return the same result as calling this object's compare or compareCollectionMembers methods

#### asCQL3Type

    public CQL3Type asCQL3Type()

Overrides:
  `asCQL3Type` in class `AbstractType<java.nio.ByteBuffer>`

#### getSerializer

    public TypeSerializer<java.nio.ByteBuffer> getSerializer()

Specified by:
  `getSerializer` in class `AbstractType<java.nio.ByteBuffer>`